﻿using Infragistics.Windows.Controls;
using Infragistics.Windows.DataPresenter;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;

namespace XDGProgrammaticFilterDemo
{
    public class MyXamDataGrid : XamDataGrid
    {


        public bool ShouldFilter
        {
            get { return (bool)GetValue(ShouldFilterProperty); }
            set { SetValue(ShouldFilterProperty, value); }
        }

        // Using a DependencyProperty as the backing store for ShouldFilter.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty ShouldFilterProperty =
            DependencyProperty.Register("ShouldFilter", typeof(bool), typeof(MyXamDataGrid), new PropertyMetadata(false, new PropertyChangedCallback(OnShouldFilterChanged)));


        private static void OnShouldFilterChanged(DependencyObject obj, DependencyPropertyChangedEventArgs e)
        {
            MyXamDataGrid xdg = obj as MyXamDataGrid;
            if (e.NewValue != null)
            {
                if ((bool)e.NewValue == true)
                {
                    RecordFilter rf =new RecordFilter(xdg.DefaultFieldLayout.Fields.Where(f => f.Name.Contains("YorN")).First());
                    rf.Conditions.Add(new ComparisonCondition(ComparisonOperator.Equals, "Y"));
                    xdg.DefaultFieldLayout.RecordFilters.Add(rf);
                }
                else
                {
                    RecordFilter rf = xdg.DefaultFieldLayout.RecordFilters.Where(f => f.Field.Name.Contains("YorN") && f.Conditions.Count != 0).First();
                    xdg.DefaultFieldLayout.RecordFilters.Remove(rf);
                }
            }
        }
    }
}
